## lemonldap-ng 2.0.14+ds

=== Makefile ===
#!/usr/bin/make

# This Makefile contains 2 main sections
#  - Variables
#  - targets

# ---------
# VARIABLES
# ---------

# Prefix for packaging
DESTDIR=

# Flag for optimizations
USEDEBIANLIBS=no
PROD=$(USEDEBIANLIBS)
USEEXTERNALLIBS=no
PARA=$(shell perl -000 -e 'print ( "$(MAKEFLAGS)" =~ /-j(\d+)/ ? "j$1:c" : "")')

# Perl options
#PERLOPTIONS="INSTALLDIRS=vendor"
PERLOPTIONS=

# Compression
JSCOMPRESS=$(PROD)
CSSCOMPRESS=$(PROD)

# External commands
PERL=$$(which perl)
PERLVERSION=`perl -e '$$version = $$^V; $$version =~ s/v//; print $$version'`
export PERL5LIB=$(shell echo `pwd`/${SRCCOMMONDIR}/blib/lib:`pwd`/${SRCHANDLERDIR}/blib/lib:`pwd`/${SRCMANAGERDIR}/blib/lib/:`pwd`/${SRCPORTALDIR}/blib/lib/)
SU=su -c
COMPRESS=tar czf
UNCOMPRESS=tar xzf
LISTCOMPRESSED=tar tzf
COMPRESSSUFFIX=tar.gz
NGINX=/usr/sbin/nginx
UGLIFYJSVERSION:=$(shell uglifyjs --version|perl -pe 's/^[^\d]*(\d).*$$/$$1/')
CHOWN=chown
CHMOD=chmod

# Default directories install
# ---------------------------

# Common dirs
PREFIX=/usr/local
LMPREFIX=$(PREFIX)/lemonldap-ng
# BIN dirs
BINDIR=$(LMPREFIX)/bin
SBINDIR=$(LMPREFIX)/sbin
INITDIR=$(LMPREFIX)/etc/init.d
ETCDEFAULTDIR=$(LMPREFIX)/etc/default
DATADIR=$(LMPREFIX)/data

# Document roots for Apache VirtualHosts
DOCUMENTROOT=$(LMPREFIX)/htdocs
PORTALDIR=$(DOCUMENTROOT)/portal
PORTALSITEDIR=$(PORTALDIR)/htdocs
PORTALSTATICDIR=$(PORTALSITEDIR)/static
PORTALRELATIVESTATICDIR=/static
PORTALTEMPLATESDIR=$(PORTALDIR)/templates

MANAGERDIR=$(DOCUMENTROOT)/manager
MANAGERSITEDIR=$(MANAGERDIR)/htdocs
MANAGERAPIDIR=$(MANAGERDIR)/api
MANAGERSTATICDIR=$(MANAGERSITEDIR)/static
MANAGERRELATIVESTATICDIR=/static
MANAGERTEMPLATESDIR=$(MANAGERSITEDIR)/templates
DOCDIR=$(DOCUMENTROOT)
DEFDOCDIR=$(DOCUMENTROOT)/doc
TESTDIR=$(DOCUMENTROOT)/test
EXAMPLESDIR=$(LMPREFIX)/examples
TOOLSDIR=$(LMPREFIX)/tools

# Handler dir
HANDLERDIR=$(LMPREFIX)/handler

# Configuration dir
CONFDIR=$(LMPREFIX)/etc
CRONDIR=$(LMPREFIX)/etc/cron.d
CONFFILENAME=lemonldap-ng.ini
STORAGECONFFILE=$(CONFDIR)/$(CONFFILENAME)

# LL::NG configuration storage dir
FILECONFIGDIR=$(DATADIR)/conf

# LL::NG sessions storage dir
APACHESESSIONFILEDIR=$(DATADIR)/sessions
APACHESESSIONFILELOCKDIR=$(APACHESESSIONFILEDIR)/lock

# LL::NG persistent sessions storage dir
APACHEPSESSIONFILEDIR=$(DATADIR)/psessions
APACHEPSESSIONFILELOCKDIR=$(APACHEPSESSIONFILEDIR)/lock

# LL::NG notifications storage dir
APACHEFILENOTIFDIR=$(DATADIR)/notifications

# LL::NG captcha dir
CAPTCHADIR=$(DATADIR)/captcha

# LL::NG cache dir
CACHEDIR=$(DATADIR)/cache

# Apache user/group
APACHEUSER=
APACHEGROUP=

# FastCGI
FASTCGISOCKDIR=$(PREFIX)/run
FASTCGIUSER=$(APACHEUSER)
FASTCGIGROUP=$(APACHEGROUP)

# uWSGI
UWSGIYAMLDIR=$(LMPREFIX)/uwsgi
LLNGAPPDIR=$(LMPREFIX)/llng-server
UWSGIUSER=$(APACHEUSER)
UWSGIGROUP=$(APACHEGROUP)

# Apache version
APACHEVERSION=2.X

# Apache log dir
APACHELOGDIR=/var/log/apache2

# DNS Domain for cookie and virtual hosts
DNSDOMAIN=example.com

# Virtual Host Listen IP and Port (*, *:80, ...)
PORT=80
VHOSTLISTEN="*:$(PORT)"
TESTWEBSERVER=apache
TESTWEBSERVERPORT=19876
TESTUSESSL=0
E2E_TESTS='portal/*.js'

# LDAP backend test
LLNGTESTLDAP_SLAPD_BIN=/usr/sbin/slapd
LLNGTESTLDAP_SLAPADD_BIN=/usr/sbin/slapadd
LLNGTESTLDAP_SCHEMA_DIR=/etc/ldap/schema

# Default website destination
WEBSITE_DIR=doc/sources/admin/_build/html

# Other
SRCCOMMONDIR=lemonldap-ng-common
SRCHANDLERDIR=lemonldap-ng-handler
SRCPORTALDIR=lemonldap-ng-portal
SRCMANAGERDIR=lemonldap-ng-manager
ERASECONFIG=1 # Set to 0 if you do not want to replace your configuration

# INTERNAL VARIABLES

# Internal variables used to install in $(DESTDIR)
RLMPREFIX=$(DESTDIR)/$(LMPREFIX)
RBINDIR=$(DESTDIR)/$(BINDIR)
RSBINDIR=$(DESTDIR)/$(SBINDIR)
RUWSGIYAMLDIR=$(DESTDIR)/$(UWSGIYAMLDIR)
RLLNGAPPDIR=$(DESTDIR)/$(LLNGAPPDIR)
RINITDIR=$(DESTDIR)/$(INITDIR)
RETCDEFAULTDIR=$(DESTDIR)/$(ETCDEFAULTDIR)
RDATADIR=$(DESTDIR)/$(DATADIR)
RPORTALDIR=$(DESTDIR)/$(PORTALDIR)
RPORTALSITEDIR=$(DESTDIR)/$(PORTALSITEDIR)
RPORTALSTATICDIR=$(DESTDIR)/$(PORTALSTATICDIR)
RPORTALTEMPLATESDIR=$(DESTDIR)/$(PORTALTEMPLATESDIR)
RMANAGERDIR=$(DESTDIR)/$(MANAGERDIR)
RMANAGERSITEDIR=$(DESTDIR)/$(MANAGERSITEDIR)
RMANAGERAPIDIR=$(DESTDIR)/$(MANAGERAPIDIR)
RMANAGERSTATICDIR=$(DESTDIR)/$(MANAGERSTATICDIR)
RMANAGERTEMPLATESDIR=$(DESTDIR)/$(MANAGERTEMPLATESDIR)
RDOCDIR=$(DESTDIR)/$(DOCDIR)
RDEFDOCDIR=$(DESTDIR)/$(DEFDOCDIR)
RTESTDIR=$(DESTDIR)/$(TESTDIR)
REXAMPLESDIR=$(DESTDIR)/$(EXAMPLESDIR)
RTOOLSDIR=$(DESTDIR)/$(TOOLSDIR)
RHANDLERDIR=$(DESTDIR)/$(HANDLERDIR)
RCONFDIR=$(DESTDIR)/$(CONFDIR)
RCRONDIR=$(DESTDIR)/$(CRONDIR)
RFILECONFIGDIR=$(DESTDIR)/$(FILECONFIGDIR)
RAPACHESESSIONFILEDIR=$(DESTDIR)/$(APACHESESSIONFILEDIR)
RAPACHESESSIONFILELOCKDIR=$(DESTDIR)/$(APACHESESSIONFILELOCKDIR)
RAPACHEPSESSIONFILEDIR=$(DESTDIR)/$(APACHEPSESSIONFILEDIR)
RAPACHEPSESSIONFILELOCKDIR=$(DESTDIR)/$(APACHEPSESSIONFILELOCKDIR)
RFILENOTIFDIR=$(DESTDIR)/$(APACHEFILENOTIFDIR)
RCAPTCHADIR=$(DESTDIR)/$(CAPTCHADIR)
RCACHEDIR=$(DESTDIR)/$(CACHEDIR)
RFASTCGISOCKDIR=$(DESTDIR)/$(FASTCGISOCKDIR)

VERSION=`head -n1 changelog |sed -e 's/lemonldap-ng (//' -e 's/).*$$//'`
PORTALSKINS=`ls $(SRCPORTALDIR)/site/templates/`
DIFF=diff -aurN -x '*.tpl' -x '*.bak' -x .svn -x '*.map' -x '*.min.js' -x '*.min.css' -x '*.swp' --ignore-matching-lines='.*jquery.*' --ignore-matching-lines='.*lemonldap-ng\.ini.*'
DIFFPREFIX=


MANAGERLIBSTOREMOVEFORDEBIAN=$(RMANAGERSTATICDIR)/bwr/jquery/ \
			$(RMANAGERSTATICDIR)/bwr/angular/ \
			$(RMANAGERSTATICDIR)/bwr/angular-animate/ \
			$(RMANAGERSTATICDIR)/bwr/angular-cookie/ \
			$(RMANAGERSTATICDIR)/bwr/bootstrap/ \
			$(RMANAGERSTATICDIR)/bwr/es5-shim/
PORTALLIBSTOREMOVEFORDEBIAN=$(RPORTALSTATICDIR)/bwr/bootstrap/ \
			$(RPORTALSTATICDIR)/bwr/font-awesome \
			$(RPORTALSTATICDIR)/bwr/jquery-ui \
			$(RPORTALSTATICDIR)/bwr/jquery.cookie \
			$(RPORTALSTATICDIR)/bwr/jquery
DOCLIBSTOREMOVEFORDEBIAN=pages/documentation/current/lib/tpl/bootstrap3 \
			pages/documentation/current/lib/scripts/jquery-ui*.js \
			pages/documentation/current/bootswatch/3.3.4/flatly/bootstrap.min.css
DOCEXTERNALLIBS=$(DOCLIBSTOREMOVEFORDEBIAN)
MANAGEREXTERNALLIBS=$(RMANAGERSTATICDIR)/bwr/
PORTALEXTERNALLIBS=$(PORTALLIBSTOREMOVEFORDEBIAN)

# GENERATED SRC FILES
MANAGERJSONSRC= scripts/jsongenerator.pl \
		$(SRCMANAGERDIR)/lib/Lemonldap/NG/Manager/Build.pm \
		$(SRCMANAGERDIR)/lib/Lemonldap/NG/Manager/Build/Attributes.pm \
		$(SRCMANAGERDIR)/lib/Lemonldap/NG/Manager/Build/Tree.pm \
		$(SRCMANAGERDIR)/lib/Lemonldap/NG/Manager/Build/CTrees.pm \
		$(SRCMANAGERDIR)/lib/Lemonldap/NG/Manager/Conf/Zero.pm \
		$(SRCMANAGERDIR)/lib/Lemonldap/NG/Manager/Build/PortalConstants.pm
MANAGERJSONDST=$(SRCMANAGERDIR)/site/htdocs/static/struct.json \
		$(SRCMANAGERDIR)/site/htdocs/static/reverseTree.json \
		$(SRCMANAGERDIR)/site/htdocs/static/js/conftree.js \
		$(SRCMANAGERDIR)/lib/Lemonldap/NG/Manager/Attributes.pm \
		$(SRCCOMMONDIR)/lib/Lemonldap/NG/Common/Conf/ReConstants.pm \
		$(SRCCOMMONDIR)/lib/Lemonldap/NG/Common/Conf/DefaultValues.pm \
		$(SRCCOMMONDIR)/lib/Lemonldap/NG/Common/Conf/Constants.pm \
		$(SRCPORTALDIR)/lib/Lemonldap/NG/Portal/Main/Constants.pm \
		$(SRCHANDLERDIR)/lib/Lemonldap/NG/Handler/Lib/StatusConstants.pm \
		_example/conf/lmConf-1.json



# Javascript and CSS to minify
JSSRCFILES:=$(shell find */site/htdocs/static/js $(SRCPORTALDIR)/site/htdocs/static -type f -name '*.js' ! -name '*.min.js') \
		$(SRCMANAGERDIR)/site/htdocs/static/bwr/file-saver.js/FileSaver.js
CSSSRCFILES:=$(shell find $(SRCMANAGERDIR)/site/htdocs/static  $(SRCPORTALDIR)/site/htdocs/static -type f -name '*.css' ! -name '*.min.css')

# Coffee files
MANAGERCOFFEESRCFILES:=$(shell find lemonldap-ng-manager/site/coffee -type f -name '*.coffee')
PORTALCOFFEESRCFILES:=$(shell find lemonldap-ng-portal/site/coffee -type f -name '*.coffee')
COFFEESRCFILES=$(MANAGERCOFFEESRCFILES) $(PORTALCOFFEESRCFILES)
MANAGERCOFFEEDSTFILES:=$(subst coffee/,htdocs/static/js/,$(MANAGERCOFFEESRCFILES:.coffee=.js))
PORTALCOFFEEDSTFILES:=$(subst coffee/,htdocs/static/common/js/,$(PORTALCOFFEESRCFILES:.coffee=.js))
COFFEEDSTFILES:=$(MANAGERCOFFEEDSTFILES) $(PORTALCOFFEEDSTFILES)

# Minified files
JSDSTFILES=$(JSSRCFILES:.js=.min.js)
CSSDSTFILES=$(CSSSRCFILES:.css=.min.css)

# -------
# TARGETS
# -------

# Targets section contains the following subsections:
#  - 'all' that must be defined at first
#  - configure targets
#  - make targets
#  - test targets
#  - end-to-end tests
#  - install targets
#  - cleaning targets
#  - Perl libraries uninstall targets
#  - packaging targets
#  - developper corner

all:	configure common handler manager portal documentation
	@echo
	@echo "Building succeed. Now run :"
	@echo " - 'make test' to verify your installation"
	@echo " - 'make install PROD=yes' to install all"
	@echo
	@echo "    MAKE INSTALL OPTIONS:"
	@echo "    - PROD=yes            : use js/css minified files"
	@echo "    - USEDEBIANLIBS=yes   : use some Debian shared js/css files"
	@echo "    - USEEXTERNALLIBS=yes : use external links for some js/css files"
	@echo
	@echo 'Other targets :'
	@echo " * Partial build :"
	@echo "   - portal, manager, handler"
	@echo
	@echo 'Other targets launched by "make install" :'
	@echo " * Perl libraries install :"
	@echo "   - install_libs           (all Perl libraries)"
	@echo "   - install_portal_libs"
	@echo "   - install_manager_libs"
	@echo "   - install_handler_libs"
	@echo " * Binaries install :"
	@echo "   - install_bin            ($(BINDIR))"
	@echo " * FastCGI (or uWSGI) server install (required for Nginx)"
	@echo "   - install_fastcgi_server ($(SBINDIR))"
	@echo "   - install_uwsgi_server   ($(UWSGIYAMLDIR))"
	@echo " * Web sites install :"
	@echo "   - install_site           (all sites including install_doc_site)"
	@echo "   - install_portal_site    ($(PORTALDIR))"
	@echo "   - install_manager_site   ($(MANAGERDIR))"
	@echo "   - install_handler_site   ($(HANDLERDIR))"
	@echo " * Documentation install :"
	@echo "   - install_doc_site       ($(DEFDOCDIR))"
	@echo "   - install_examples_site  ($(EXAMPLESDIR))"
	@echo

# Configure targets
# -----------------

configure:	common_conf handler_conf portal_conf manager_conf

js: $(COFFEEDSTFILES)

minify: js $(JSDSTFILES) $(CSSDSTFILES)

$(SRCPORTALDIR)/site/htdocs/static/common/js/%.js: $(SRCPORTALDIR)/site/coffee/%.coffee
	@if which coffee >/dev/null; then \
		echo "Compiling $(SRCPORTALDIR)/site/coffee/$*.coffee"; \
		coffee -c -o $(SRCPORTALDIR)/site/htdocs/static/common/js/ $(SRCPORTALDIR)/site/coffee/$*.coffee; \
	else \
		echo "Can't find coffee"; \
	fi

$(SRCMANAGERDIR)/site/htdocs/static/js/%.js: $(SRCMANAGERDIR)/site/coffee/%.coffee
	@if which coffee >/dev/null; then \
		echo "Compiling $(SRCMANAGERDIR)/site/coffee/$*.coffee"; \
		coffee -c -o $(SRCMANAGERDIR)/site/htdocs/static/js/ $(SRCMANAGERDIR)/site/coffee/$*.coffee; \
	fi

%.min.css: %.css
	@echo "Compressing $*.css"
	@yui-compressor $*.css > $*.min.css

%.min.js: %.js
	@echo "Compressing $*.js"
	if test "$(UGLIFYJSVERSION)" = 2; then \
		cd `dirname $*`; \
		uglifyjs `basename $*`.js --compress --mangle --comments '/Copyr/i' --source-map `basename $*`.min.js.map -o `basename $*`.min.js; \
	else \
		cd `dirname $*`; \
		uglifyjs `basename $*`.js --compress --mangle --comments '/Copyr/i' --source-map -o `basename $*`.min.js; \
	fi

fastcgi-server/man/llng-fastcgi-server.8p: fastcgi-server/sbin/llng-fastcgi-server
	@echo Update FastCGI server man page
	@pod2man -s 8 -name llng-fastcgi-server fastcgi-server/sbin/llng-fastcgi-server >fastcgi-server/man/llng-fastcgi-server.8p

# Perl libraries configuration

json:	$(MANAGERJSONDST) fastcgi-server/man/llng-fastcgi-server.8p debian/*cron*
	@if which yui-compressor >/dev/null; then $(MAKE) minify; fi

debian/liblemonldap-ng-handler-perl.cron.d: lemonldap-ng-handler/eg/scripts/purgeLocalCache.cron.d
	@perl -pe 's/__APACHEUSER__/www-data/g;s@__BINDIR__@/usr/share/lemonldap-ng/bin@g' \
		lemonldap-ng-handler/eg/scripts/purgeLocalCache.cron.d \
		> debian/liblemonldap-ng-handler-perl.cron.d

=== debian/changelog ===
lemonldap-ng (2.0.14+ds-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Don't require libwebauthn-perl

 -- Yadd <yadd@debian.org>  Fri, 25 Feb 2022 06:32:24 +0100

lemonldap-ng (2.0.14+ds-1) unstable; urgency=medium

  [ lintian-brush ]
  * Remove 1 obsolete maintscript entry

  [ Yadd ]
  * New upstream version 2.0.14+ds
  * Unfuzz patches
  * Update copyright

 -- Yadd <yadd@debian.org>  Wed, 23 Feb 2022 12:30:14 +0100

lemonldap-ng (2.0.14~exp+ds-1) experimental; urgency=medium

  * Add FastCGI server test
  * Update excluded files list
  * New upstream version 2.0.14~exp+ds (Closes: #1005302, CVE-2021-40874)
  * Drop quick-fix.patch
  * Update install
  * Add optional dependencies to liblist-moreutils-perl,
    libauthen-webauthn-perl and libauthen-radius-perl
  * Update lintian overrides
  * Update copyright

 -- Yadd <yadd@debian.org>  Thu, 17 Feb 2022 14:43:59 +0100

lemonldap-ng (2.0.13+ds-3~bpo10+3) buster-backports; urgency=medium

  * Bump debhelper-compat to 13, this fixes missing systemd tmpfile
    configuration for fastcgi server. Thanks to Dominique Fournier for the
    report.

 -- Yadd <yadd@debian.org>  Wed, 05 Jan 2022 11:36:24 +0100

lemonldap-ng (2.0.13+ds-3~bpo10+2) buster-backports; urgency=medium

  * Rebuild for buster-backports

 -- Yadd <yadd@debian.org>  Tue, 21 Dec 2021 12:09:06 +0100

lemonldap-ng (2.0.13+ds-3~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports-sloppy

 -- Yadd <yadd@debian.org>  Mon, 11 Oct 2021 06:52:20 +0200

lemonldap-ng (2.0.13+ds-2~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports-sloppy

 -- Yadd <yadd@debian.org>  Thu, 02 Sep 2021 08:11:57 +0200

lemonldap-ng (2.0.13+ds-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports-sloppy

 -- Yadd <yadd@debian.org>  Wed, 25 Aug 2021 06:45:44 +0200

lemonldap-ng (2.0.11+ds-4~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Yadd <yadd@debian.org>  Wed, 28 Jul 2021 07:31:43 +0200

lemonldap-ng (2.0.11+ds-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Yadd <yadd@debian.org>  Thu, 08 Jul 2021 16:06:08 +0200

lemonldap-ng (2.0.11+ds-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Xavier Guimard <yadd@debian.org>  Tue, 09 Feb 2021 06:07:02 +0100

=== debian/control ===
Source: lemonldap-ng
Maintainer: Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>
Uploaders: Yadd <yadd@debian.org>
Section: perl
Priority: optional
Build-Depends: debhelper-compat (= 13),
               po-debconf
Build-Depends-Indep: gpg <!nocheck>,
                     gsfonts <!nocheck>,
                     libapache-session-perl <!nocheck>,
                     libauth-yubikey-webclient-perl <!nocheck>,
                     libauthen-oath-perl <!nocheck>,
                     libauthen-radius-perl <!nocheck>,
                     libauthen-u2f-tester-perl <!nocheck>,
                     libcache-cache-perl <!nocheck>,
                     libclone-perl <!nocheck>,
                     libconfig-inifiles-perl <!nocheck>,
                     libconvert-base32-perl <!nocheck>,
                     libconvert-pem-perl <!nocheck>,
                     libcrypt-openssl-rsa-perl <!nocheck>,
                     libcrypt-openssl-x509-perl <!nocheck>,
                     libcrypt-urandom-perl <!nocheck>,
                     libcrypt-rijndael-perl <!nocheck>,
                     libcrypt-u2f-server-perl <!nocheck>,
                     libdatetime-format-rfc3339-perl <!nocheck>,
                     libdbd-sqlite3-perl <!nocheck>,
                     libdbi-perl <!nocheck>,
                     libdigest-hmac-perl <!nocheck>,
                     libemail-sender-perl <!nocheck>,
                     libgd-securityimage-perl <!nocheck>,
                     libglib-perl <!nocheck>,
                     libgssapi-perl <!nocheck>,
                     libhtml-template-perl <!nocheck>,
                     libimage-magick-perl <!nocheck>,
                     libio-string-perl <!nocheck>,
                     libipc-run-perl <!nocheck>,
                     liblist-moreutils-perl <!nocheck>,
                     libjson-perl <!nocheck>,
                     libjson-xs-perl <!nocheck>,
                     liblasso-perl <!nocheck>,
                     liblwp-protocol-psgi-perl,
                     libmime-tools-perl <!nocheck>,
                     libmouse-perl <!nocheck>,
                     libnet-cidr-lite-perl <!nocheck>,
                     libnet-ldap-perl <!nocheck>,
                     libio-socket-timeout-perl <!nocheck>,
                     libnet-openid-consumer-perl <!nocheck>,
                     libnet-openid-server-perl <!nocheck>,
                     libplack-perl <!nocheck>,
                     libregexp-assemble-perl <!nocheck>,
                     libregexp-common-perl <!nocheck>,
                     libsoap-lite-perl <!nocheck>,
                     libstring-random-perl <!nocheck>,
                     libtest-mockobject-perl <!nocheck>,
                     libtest-output-perl <!nocheck>,
                     libtest-pod-perl <!nocheck>,
                     libtext-unidecode-perl <!nocheck>,
                     libtime-fake-perl <!nocheck>,
                     libunicode-string-perl <!nocheck>,
                     liburi-perl <!nocheck>,
                     libhttp-message-perl <!nocheck>,
                     libwww-perl <!nocheck>,
                     libxml-libxml-perl <!nocheck>,
                     libxml-libxslt-perl <!nocheck>,
                     libxml-simple-perl <!nocheck>,
                     libtest-leaktrace-perl <!nocheck>,
                     python3-sphinx,
                     python3-sphinx-bootstrap-theme,
                     uglifyjs,
                     yui-compressor,
                     perl
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/perl-team/modules/packages/lemonldap-ng
Vcs-Git: https://salsa.debian.org/perl-team/modules/packages/lemonldap-ng.git
Homepage: https://lemonldap-ng.org/
Rules-Requires-Root: binary-targets

Package: lemonldap-ng
Architecture: all
Depends: ${misc:Depends},
         lemonldap-ng-handler (= ${binary:Version}),
         liblemonldap-ng-manager-perl (= ${binary:Version}),
         liblemonldap-ng-portal-perl (= ${binary:Version})
Provides: openid-connect-provider,
          openid-connect-relying-party,
          saml-identity-provider,
          saml-service-provider
Description: OpenID-Connect, CAS and SAML compatible Web-SSO system
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application webservers. It can be used in conjunction with
 OpenID-Connect, CAS and SAML systems as identity or service provider. It can
 also be used as proxy between those federation systems.
 .
 It manages both authentication and authorization and provides headers for
 accounting. So you can have a full AAA protection. Authorizations are built by
 associating a regular expression and a rule. Regular expression is applied on
 the requested URL and the rule calculates if the user is authorized.
 .
 This package is a metapackage that install handler, manager and portal.

Package: lemonldap-ng-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Lemonldap::NG Web-SSO system documentation
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application webservers. It can be used in conjunction with
 OpenID-Connect, CAS and SAML systems as identity or service provider. It can
 also be used as proxy between those federation systems.
 .
 It manages both authentication and authorization and provides headers for
 accounting. So you can have a full AAA protection. Authorizations are built by
 associating a regular expression and a rule. Regular expression is applied on
 the requested URL and the rule calculates if the user is authorized.
 .
 This package contains html documentation.

Package: lemonldap-ng-fastcgi-server
Architecture: all
Section: web
Depends: ${misc:Depends},
         ${perl:Depends},
         lsb-base,
         libfcgi-perl,
         libfcgi-procmanager-perl,
         liblemonldap-ng-handler-perl (= ${binary:Version}),
         libplack-perl
Recommends: libhttp-parser-xs-perl,
            nginx-extras | nginx
Pre-Depends: ${misc:Pre-Depends}
Description: Lemonldap::NG FastCGI server
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application webservers. It can be used in conjunction with
 OpenID-Connect, CAS and SAML systems as identity or service provider. It can
 also be used as proxy between those federation systems.
 .
 It manages both authentication and authorization and provides headers for
 accounting. So you can have a full AAA protection. Authorizations are built by
 associating a regular expression and a rule. Regular expression is applied on
 the requested URL and the rule calculates if the user is authorized.
 .
 Lemonldap::NG FastCGI server provides a Nginx auth_request server that handles
 also LLNG Portal and Manager.

Package: lemonldap-ng-uwsgi-app
Architecture: all
Section: web
Depends: ${misc:Depends},
         liblemonldap-ng-handler-perl (= ${binary:Version})
Recommends: libhttp-parser-xs-perl,
            uwsgi-plugin-psgi
Suggests: nginx-extras | nginx
Description: Lemonldap::NG uWSGI server
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application webservers. It can be used in conjunction with
 OpenID-Connect, CAS and SAML systems as identity or service provider. It can
 also be used as proxy between those federation systems.
 .
 It manages both authentication and authorization and provides headers for
 accounting. So you can have a full AAA protection. Authorization are built by
 associating a regular expression and a rule. Regular expression is applied on
 the requested URL and the rule calculates if the user is authorized.
 .
 Lemonldap::NG uWSGI server provides a replacement to Lemonldap::NG FastCGI
 server, using uWSGI instead of Plack FCGI.

Package: lemonldap-ng-handler
Architecture: all
Depends: ${misc:Depends},
         liblemonldap-ng-handler-perl (= ${binary:Version})
Recommends: lemonldap-ng-fastcgi-server (= ${binary:Version}) | lemonldap-ng-uwsgi-app (= ${binary:Version}) | libapache2-mod-perl2
Suggests: libcache-memcached-perl,
          libdigest-hmac-perl,
          libsoap-lite-perl
Breaks: lemonldap-ng-fastcgi-server (<< 2.0.5~)
Replaces: lemonldap-ng-fastcgi-server (<< 2.0.5~)
Description: Lemonldap::NG handler part
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application webservers. It can be used in conjunction with
 OpenID-Connect, CAS and SAML systems as identity or service provider. It can
 also be used as proxy between those federation systems.
 .
 It manages both authentication and authorization and provides headers for
 accounting. So you can have a full AAA protection. Authorizations are built by
 associating a regular expression and a rule. Regular expression is applied on
 the requested URL and the rule calculates if the user is authorized.
 .
 This package provides configuration files for Apache and Nginx used to protect
 web areas.

Package: liblemonldap-ng-handler-perl
Architecture: all
Depends: ${misc:Depends},
         ${perl:Depends},
         liblemonldap-ng-common-perl (= ${binary:Version})
Description: Lemonldap::NG handler common libraries
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application webservers. It can be used in conjunction with
 OpenID-Connect, CAS and SAML systems as identity or service provider. It can
 also be used as proxy between those federation systems.
 .
 It manages both authentication and authorization and provides headers for
 accounting. So you can have a full AAA protection. Authorizations are built by
 associating a regular expression and a rule. Regular expression is applied on
 the requested URL and the rule calculates if the user is authorized.
 .
 Lemonldap::NG::Handler provides Perl libraries used by web server handlers.

Package: liblemonldap-ng-common-perl
Architecture: all
Depends: ${misc:Depends},
         ${perl:Depends},
         debconf,
         libapache-session-perl,
         libcache-cache-perl,
         libconfig-inifiles-perl,
         libcrypt-openssl-rsa-perl,
         libcrypt-openssl-x509-perl,
         libcrypt-urandom-perl,
         libcrypt-rijndael-perl,
         libhtml-template-perl,
         libjson-perl,
         libjson-xs-perl,
         libmouse-perl,
         libplack-perl,
         liburi-perl,
         libwww-perl
Recommends: libapache-session-browseable-perl,
            libemail-sender-perl,
            libcookie-baker-xs-perl,
            libdbi-perl,
            libhttp-parser-xs-perl,
            liblwp-protocol-https-perl,
            libstring-random-perl
Suggests: libconvert-base32-perl,
          libnet-ldap-perl,
          libsoap-lite-perl,
          libxml-libxml-perl,
          libxml-simple-perl
Description: Lemonldap::NG common files
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application webservers. It can be used in conjunction with
 OpenID-Connect, CAS and SAML systems as identity or service provider. It can
 also be used as proxy between those federation systems.
 .
 It manages both authentication and authorization and provides headers for
 accounting. So you can have a full AAA protection. Authorizations are built by
 associating a regular expression and a rule. Regular expression is applied on
 the requested URL and the rule calculates if the user is authorized.
 .
 Lemonldap::NG::Common contains common files used by other Lemonldap::NG
 modules.

Package: liblemonldap-ng-manager-perl
Architecture: all
Depends: ${misc:Depends},
         ${perl:Depends},
         libconvert-pem-perl,
         libregexp-common-perl,
         libcrypt-openssl-rsa-perl,
         libemail-date-format-perl,
         libjs-angularjs,
         libjs-bootstrap,
         libjs-es5-shim,
         libjs-jquery,

## lemonldap-ng 2.0.15.1+ds

=== Makefile ===
--- 
+++ 
@@ -65,6 +65,7 @@
 MANAGERAPIDIR=$(MANAGERDIR)/api
 MANAGERSTATICDIR=$(MANAGERSITEDIR)/static
 MANAGERRELATIVESTATICDIR=/static
+MANAGERRELATIVEDOCDIR=/doc
 MANAGERTEMPLATESDIR=$(MANAGERSITEDIR)/templates
 DOCDIR=$(DOCUMENTROOT)
 DEFDOCDIR=$(DOCUMENTROOT)/doc
@@ -349,5 +350,3 @@
 debian/liblemonldap-ng-handler-perl.cron.d: lemonldap-ng-handler/eg/scripts/purgeLocalCache.cron.d
 	@perl -pe 's/__APACHEUSER__/www-data/g;s@__BINDIR__@/usr/share/lemonldap-ng/bin@g' \
 		lemonldap-ng-handler/eg/scripts/purgeLocalCache.cron.d \
-		> debian/liblemonldap-ng-handler-perl.cron.d
-

=== debian/changelog ===
lemonldap-ng (2.0.15.1+ds-1) unstable; urgency=medium

  * Apply multi-arch hints (liblemonldap-ng-ssoaas-apache-client-perl: foreign)
  * Update lintian overrides
  * New upstream version (Closes: #1019873)

 -- Yadd <yadd@debian.org>  Fri, 16 Sep 2022 06:25:57 +0200

lemonldap-ng (2.0.15+ds-2) unstable; urgency=medium

  * Source only upload
  * Fix autopkgtest

 -- Yadd <yadd@debian.org>  Sun, 11 Sep 2022 14:59:47 +0200

lemonldap-ng (2.0.15+ds-1) unstable; urgency=medium

  * Update lintian overrides
  * Declare compliance with policy 4.6.1
  * Apply multi-arch hints (lemonldap-ng-doc: foreign)
  * Update lintian overrides
  * New upstream version 2.0.15+ds (Closes: CVE-2022-37186)
  * Unfuzz patches
  * Install new liblemonldap-ng-SSOaaS::Apache::Client

 -- Yadd <yadd@debian.org>  Sun, 11 Sep 2022 08:02:48 +0200

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
                      libauth-yubikey-webclient-perl <!nocheck>,
                      libauthen-oath-perl <!nocheck>,
                      libauthen-radius-perl <!nocheck>,
+                     libauthen-webauthn-perl <!nocheck>,
                      libauthen-u2f-tester-perl <!nocheck>,
                      libcache-cache-perl <!nocheck>,
                      libclone-perl <!nocheck>,
@@ -30,25 +31,26 @@
                      libgd-securityimage-perl <!nocheck>,
                      libglib-perl <!nocheck>,
                      libgssapi-perl <!nocheck>,
+                     libhash-merge-simple-perl <!nocheck>,
                      libhtml-template-perl <!nocheck>,
                      libimage-magick-perl <!nocheck>,
-                     libio-string-perl <!nocheck>,
+                     libio-string-perl,
                      libipc-run-perl <!nocheck>,
                      liblist-moreutils-perl <!nocheck>,
-                     libjson-perl <!nocheck>,
+                     libjson-perl,
                      libjson-xs-perl <!nocheck>,
                      liblasso-perl <!nocheck>,
                      liblwp-protocol-psgi-perl,
                      libmime-tools-perl <!nocheck>,
-                     libmouse-perl <!nocheck>,
+                     libmouse-perl,
                      libnet-cidr-lite-perl <!nocheck>,
                      libnet-ldap-perl <!nocheck>,
                      libio-socket-timeout-perl <!nocheck>,
                      libnet-openid-consumer-perl <!nocheck>,
                      libnet-openid-server-perl <!nocheck>,
                      libplack-perl <!nocheck>,
-                     libregexp-assemble-perl <!nocheck>,
-                     libregexp-common-perl <!nocheck>,
+                     libregexp-assemble-perl,
+                     libregexp-common-perl,
                      libsoap-lite-perl <!nocheck>,
                      libstring-random-perl <!nocheck>,
                      libtest-mockobject-perl <!nocheck>,
@@ -69,7 +71,7 @@
                      uglifyjs,
                      yui-compressor,
                      perl
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/perl-team/modules/packages/lemonldap-ng
 Vcs-Git: https://salsa.debian.org/perl-team/modules/packages/lemonldap-ng.git
 Homepage: https://lemonldap-ng.org/
@@ -103,6 +105,7 @@
 Section: doc
 Depends: ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: foreign
 Description: Lemonldap::NG Web-SSO system documentation
  Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
  or directly on application webservers. It can be used in conjunction with
@@ -142,6 +145,18 @@
  .
  Lemonldap::NG FastCGI server provides a Nginx auth_request server that handles
  also LLNG Portal and Manager.
+
+Package: liblemonldap-ng-ssoaas-apache-client-perl
+Architecture: all
+Section: web
+Depends: ${misc:Depends},
+         ${perl:Depends}
+Breaks: liblemonldap-ng-handler-perl (<< 2.0.14~)
+Multi-Arch: foreign
+Description: Lemonldap::NG SSOaaS client for Apache
+ Lemonldap::NG is a complete Web-SSO system that provides a SSO-as-a-Service
+ system, natively usable with Nginx. Lemonldap::NG::SSOaaS::Apache::Client
+ permits one to enroll an Apache server into Lemonldap::NG's SSOaaS service.
 
 Package: lemonldap-ng-uwsgi-app
 Architecture: all
@@ -246,21 +261,3 @@
  .
  It manages both authentication and authorization and provides headers for
  accounting. So you can have a full AAA protection. Authorizations are built by
- associating a regular expression and a rule. Regular expression is applied on
- the requested URL and the rule calculates if the user is authorized.
- .
- Lemonldap::NG::Common contains common files used by other Lemonldap::NG
- modules.
-
-Package: liblemonldap-ng-manager-perl
-Architecture: all
-Depends: ${misc:Depends},
-         ${perl:Depends},
-         libconvert-pem-perl,
-         libregexp-common-perl,
-         libcrypt-openssl-rsa-perl,
-         libemail-date-format-perl,
-         libjs-angularjs,
-         libjs-bootstrap,
-         libjs-es5-shim,
-         libjs-jquery,

## lemonldap-ng 2.0.16+ds

=== debian/changelog ===
lemonldap-ng (2.0.16+ds-4) unstable; urgency=medium

  * Really drop network test

 -- Yadd <yadd@debian.org>  Sun, 05 Feb 2023 17:59:56 +0400

lemonldap-ng (2.0.16+ds-3) unstable; urgency=medium

  * Drop network test

 -- Yadd <yadd@debian.org>  Sun, 05 Feb 2023 17:14:19 +0400

lemonldap-ng (2.0.16+ds-2) unstable; urgency=medium

  * Add libhttp-browserdetect-perl and libgeoip2-perl in autopkgtest
    dependencies (test: runtime-deps-and-recommends)

 -- Yadd <yadd@debian.org>  Sun, 05 Feb 2023 07:55:20 +0400

lemonldap-ng (2.0.16+ds-1) unstable; urgency=medium

  [ lintian-brush ]
  * Update lintian override info to new format:
    + debian/source/lintian-overrides: line 5-6
    + debian/liblemonldap-ng-manager-perl.lintian-overrides: line 2, 4
  * Set upstream metadata fields: Bug-Database.
  * Update standards version to 4.6.2, no changes needed.

  [ Yadd ]
  * Replace gsfonts by fonts-urw-base35 (Closes: #1020360)
  * New upstream version 2.0.16+ds
  * Unfuzz patches
  * Add dependency to libnginx-mod-http-lua, libclass-xsaccessor-perl,
    libgeoip2-perl and libhttp-browserdetect-perl

 -- Yadd <yadd@debian.org>  Wed, 01 Feb 2023 19:43:56 +0400

lemonldap-ng (2.0.15.1+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to rebuild with debhelper 13.10.

 -- Michael Biebl <biebl@debian.org>  Sat, 15 Oct 2022 12:14:47 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                po-debconf
 Build-Depends-Indep: gpg <!nocheck>,
-                     gsfonts <!nocheck>,
+                     fonts-urw-base35 <!nocheck>,
                      libapache-session-perl <!nocheck>,
                      libauth-yubikey-webclient-perl <!nocheck>,
                      libauthen-oath-perl <!nocheck>,
@@ -14,6 +14,7 @@
                      libauthen-webauthn-perl <!nocheck>,
                      libauthen-u2f-tester-perl <!nocheck>,
                      libcache-cache-perl <!nocheck>,
+                     libclass-xsaccessor-perl <!nocheck>,
                      libclone-perl <!nocheck>,
                      libconfig-inifiles-perl <!nocheck>,
                      libconvert-base32-perl <!nocheck>,
@@ -71,7 +72,7 @@
                      uglifyjs,
                      yui-compressor,
                      perl
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/perl-team/modules/packages/lemonldap-ng
 Vcs-Git: https://salsa.debian.org/perl-team/modules/packages/lemonldap-ng.git
 Homepage: https://lemonldap-ng.org/
@@ -130,6 +131,7 @@
          liblemonldap-ng-handler-perl (= ${binary:Version}),
          libplack-perl
 Recommends: libhttp-parser-xs-perl,
+            libnginx-mod-http-lua,
             nginx-extras | nginx
 Pre-Depends: ${misc:Pre-Depends}
 Description: Lemonldap::NG FastCGI server
@@ -238,6 +240,7 @@
          libjson-perl,
          libjson-xs-perl,
          libmouse-perl,
+         libclass-xsaccessor-perl,
          libplack-perl,
          liburi-perl,
          libwww-perl
@@ -260,4 +263,3 @@
  also be used as proxy between those federation systems.
  .
  It manages both authentication and authorization and provides headers for
- accounting. So you can have a full AAA protection. Authorizations are built by

## lemonldap-ng 2.16.1+ds

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,8 @@
 USEDEBIANLIBS=no
 PROD=$(USEDEBIANLIBS)
 USEEXTERNALLIBS=no
-PARA=$(shell perl -000 -e 'print ( "$(MAKEFLAGS)" =~ /-j(\d+)/ ? "j$1:c" : "")')
+PARA=$(shell perl -000 -e 'print ( "$(MAKEFLAGS)" =~ /-j(\d+)/ ? "j$$1:c" : "")')
+PARAXARGS=$(shell perl -000 -e 'print ( "$(MAKEFLAGS)" =~ /-j(\d+)/ ? "-P $$1" : "")')
 
 # Perl options
 #PERLOPTIONS="INSTALLDIRS=vendor"
@@ -348,5 +349,3 @@
 	@if which yui-compressor >/dev/null; then $(MAKE) minify; fi
 
 debian/liblemonldap-ng-handler-perl.cron.d: lemonldap-ng-handler/eg/scripts/purgeLocalCache.cron.d
-	@perl -pe 's/__APACHEUSER__/www-data/g;s@__BINDIR__@/usr/share/lemonldap-ng/bin@g' \
-		lemonldap-ng-handler/eg/scripts/purgeLocalCache.cron.d \

=== debian/changelog ===
lemonldap-ng (2.16.1+ds-deb12u6) bookworm-security; urgency=high

  * Fix XSS vulnerability in Choice module (Closes: CVE-2025-31510)

 -- Yadd <yadd@debian.org>  Tue, 01 Apr 2025 13:39:12 +0200

lemonldap-ng (2.16.1+ds-deb12u5) bookworm; urgency=medium

  * Fix CSRF on 2FA registration interface (Closes: CVE-2024-52948)

 -- Yadd <yadd@debian.org>  Sun, 02 Feb 2025 12:04:04 +0100

lemonldap-ng (2.16.1+ds-deb12u4) bookworm; urgency=medium

  * Fix authentication privilege (Closes: CVE-2024-52946)
  * Fix XSS in "Upgrade" plugin (Closes: CVE-2024-52947)

 -- Yadd <yadd@debian.org>  Tue, 19 Nov 2024 18:44:18 +0100

lemonldap-ng (2.16.1+ds-deb12u3) bookworm; urgency=medium

  * Fix XSS issue (Closes: #1084979, CVE-2024-48933)

 -- Yadd <yadd@debian.org>  Tue, 15 Oct 2024 20:59:06 +0200

lemonldap-ng (2.16.1+ds-deb12u2) bookworm; urgency=medium

  * Fix open redirection when OIDC RP has no redirect uris
  * Fix Server-Side-Request-Forgery issue in OIDC (CVE-2023-44469)

 -- Yadd <yadd@debian.org>  Fri, 29 Sep 2023 17:18:12 +0400

lemonldap-ng (2.16.1+ds-deb12u1) bookworm; urgency=medium

  * Apply login control to auth-slave requests
  * Fix open redirection due to incorrect escape handling

 -- Yadd <yadd@debian.org>  Sun, 24 Sep 2023 06:47:35 +0400

lemonldap-ng (2.16.1+ds-2) unstable; urgency=medium

  * Fix incorrect parsing of OP-provided acr
  * Fix regression introduced in 2.16.1 that render viewer unusable

 -- Yadd <yadd@debian.org>  Fri, 12 May 2023 21:10:49 +0400

lemonldap-ng (2.16.1+ds-1) unstable; urgency=medium

  * Update debian/clean: clean sphynx lock
  * Suggests crowdsec
  * Remove old hook that breaks documentation
  * New upstream release (Closes CVE-2023-28862)

 -- Yadd <yadd@debian.org>  Wed, 29 Mar 2023 14:46:10 +0400

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

LMSHAREDIR=/usr/share/lemonldap-ng
LMVARDIR  =/var/lib/lemonldap-ng
TMP       = $(CURDIR)/debian/tmp

CONFDIR=/etc/lemonldap-ng
CACHEDIR=$(LMVARDIR)/cache
SESSIONSDIR=$(LMVARDIR)/sessions
PSESSIONSDIR=$(LMVARDIR)/psessions
NOTIFICATIONSDIR=$(LMVARDIR)/notifications
CONFSTORAGEDIR=$(LMVARDIR)/conf
FIRSTCONFFILE=$(CONFSTORAGEDIR)/lmConf-1.json
LMINIFILE=$(CONFDIR)/lemonldap-ng.ini
CAPTCHADIR=$(LMVARDIR)/captcha
export LLNG_SKIP_GPG_TEST=1

%:
	dh $@

override_dh_auto_configure:
	$(MAKE) lemonldap-ng-common/lib/Lemonldap/NG/Common/Conf/Constants.pm \
		fastcgi-server/man/llng-fastcgi-server.8p
	$(MAKE) configure STORAGECONFFILE=/etc/lemonldap-ng/lemonldap-ng.ini \
		PERLOPTIONS="INSTALLDIRS=vendor"

override_dh_auto_build:
	# Generate files excluded from import
	$(MAKE) all

override_dh_auto_install:
	$(MAKE) install \
			DESTDIR=$(CURDIR)/debian/tmp \
			PREFIX=/usr \
			LMPREFIX=/usr/share/lemonldap-ng \
			BINDIR=$(LMSHAREDIR)/bin \
			SBINDIR=/usr/sbin \
			FASTCGISOCKDIR=/var/run/llng-fastcgi-server \
			DOCUMENTROOT=$(LMVARDIR) \
			EXAMPLESDIR=/examples \
			HANDLERDIR=$(LMVARDIR)/handler \
			MANAGERDIR=$(LMSHAREDIR)/manager \
			PORTALDIR=$(LMSHAREDIR)/portal \
			STORAGECONFFILE=/etc/lemonldap-ng/lemonldap-ng.ini \
			TOOLSDIR=$(LMSHAREDIR)/ressources \
			CONFDIR=/etc/lemonldap-ng \
			CRONDIR=/etc/cron.d \
			DATADIR=$(LMVARDIR) \
			APACHEVERSION=2.X \
			APACHEUSER=www-data \
			APACHEGROUP=www-data \
			DEFDOCDIR=/usr/share/doc/lemonldap-ng \
			UWSGIYAMLDIR=/etc/uwsgi/apps-available \
			USEDEBIANLIBS=yes
	find $(TMP)/$(LMSHAREDIR) -type f -name '.*.swp' -delete
	# Generate minified files removed by uscan
	for i in $$(find $(TMP)/$(LMSHAREDIR) -type f -name '*.js'); do \
		echo -n "compressing $$i: "; \
		uglifyjs --comments '/Copyr/i' $$i >$${i%%.js}.min.js; \
		echo done; \
	done
	for i in $$(find $(TMP)/$(LMSHAREDIR) -type f -name '*.css'); do \
		echo -n "compressing $$i: "; \
		yui-compressor $$i >$${i%%.css}.min.css; \
		echo done; \
	done

override_dh_compress:
	dh_compress -X favicon.ico

# Fix lemonldap-ng dirs permissions and owner since dh_fixperms change them:
#  * global configuration dirs must be writable by www-data but not readable
#    by all (also sessions, captcha,... dirs)
#  * lemonldap-ng.ini must not be readable by all
override_dh_fixperms:
	dh_fixperms
	chown www-data:www-data \
		debian/*/$(CACHEDIR) \
		debian/*/$(SESSIONSDIR) \
		debian/*/$(SESSIONSDIR)/lock \
		debian/*/$(PSESSIONSDIR) \
		debian/*/$(PSESSIONSDIR)/lock \
		debian/*/$(NOTIFICATIONSDIR) \
		debian/liblemonldap-ng-common-perl/$(CONFSTORAGEDIR) \
		debian/liblemonldap-ng-portal-perl/$(CAPTCHADIR)
	chgrp www-data debian/liblemonldap-ng-common-perl/$(LMINIFILE) \
		debian/liblemonldap-ng-common-perl/$(FIRSTCONFFILE)
	chmod 770 debian/*/$(SESSIONSDIR) debian/*/$(SESSIONSDIR)/lock \
	        debian/*/$(PSESSIONSDIR) debian/*/$(PSESSIONSDIR)/lock \
		debian/*/$(CACHEDIR) \
		debian/*/$(NOTIFICATIONSDIR) \
		debian/liblemonldap-ng-portal-perl/$(CAPTCHADIR)
	chmod 750 debian/liblemonldap-ng-common-perl/$(CONFSTORAGEDIR)
	chmod 640 debian/liblemonldap-ng-common-perl/$(FIRSTCONFFILE) \
		debian/liblemonldap-ng-common-perl/$(LMINIFILE)

override_dh_missing:
	dh_missing -Xexamples/ -Xetc/cron.d -Xllng-fastcgi-server

=== debian/tests/control ===
# FastCGI server
Tests: fastcgiserver
Depends: @
 , libfcgi-client-perl
 , libstring-random-perl
 , libemail-sender-perl
 , libmime-tools-perl
 , libgd-securityimage-perl
 , libimage-magick-perl
Restrictions: allow-stderr, needs-root

# debian/tests/runner launch pkg-perl-autopkgtest tests for each library
Test-Command: ./debian/tests/runner build-deps lemonldap-ng-common
Depends: liblemonldap-ng-common-perl, @builddeps@, pkg-perl-autopkgtest
Features: test-name=common-test

Test-Command: ./debian/tests/runner build-deps lemonldap-ng-handler
Depends: liblemonldap-ng-handler-perl, @builddeps@, pkg-perl-autopkgtest
Features: test-name=handler-test

Test-Command: ./debian/tests/runner build-deps lemonldap-ng-portal
Depends: liblemonldap-ng-portal-perl, @builddeps@, pkg-perl-autopkgtest
Features: test-name=portal-test

Test-Command: ./debian/tests/runner build-deps lemonldap-ng-manager
Depends: liblemonldap-ng-manager-perl, @builddeps@, pkg-perl-autopkgtest
Features: test-name=manager-test

Test-Command: ./debian/tests/runner runtime-deps lemonldap-ng-common
Depends: liblemonldap-ng-common-perl, pkg-perl-autopkgtest, libmouse-perl
Restrictions: superficial, skippable
Features: test-name=runtime-deps-common

# Disable this one: skipped
#Test-Command: ./debian/tests/runner runtime-deps lemonldap-ng-handler
#Depends: liblemonldap-ng-handler-perl, pkg-perl-autopkgtest, libmouse-perl
#Restrictions: superficial, skippable
#Features: test-name=runtime-deps-handler

Test-Command: ./debian/tests/runner runtime-deps lemonldap-ng-portal
Depends: liblemonldap-ng-portal-perl, pkg-perl-autopkgtest, libmouse-perl
Restrictions: superficial, skippable
Features: test-name=runtime-deps-portal

Test-Command: ./debian/tests/runner runtime-deps lemonldap-ng-manager
Depends: liblemonldap-ng-manager-perl, pkg-perl-autopkgtest, libmouse-perl
Restrictions: superficial, skippable
Features: test-name=runtime-deps-manager

# Use pkg-perl-autopkgtest test for runtime-deps-and-recommends
# Some portal suggested dependencies are added here
Test-Command: /usr/share/pkg-perl-autopkgtest/runner runtime-deps-and-recommends
Depends: @, @builddeps@, pkg-perl-autopkgtest
 , libauthen-pam-perl
 , libauthen-radius-perl
 , libdatetime-format-rfc3339-perl
 , libgeoip2-perl
 , libhttp-browserdetect-perl
 , libio-socket-timeout-perl
 , liblog-log4perl-perl
 , libweb-id-perl
 , libyaml-perl
Restrictions: superficial
Features: test-name=runtime-deps-and-recommends

#Test-Command: ./debian/tests/runner heavy-deps
#Depends: @, pkg-perl-autopkgtest, pkg-perl-autopkgtest-heavy, libmouse-perl
#Features: test-name=heavy-deps

## lemonldap-ng 2.16.2+ds

=== debian/changelog ===
lemonldap-ng (2.16.2+ds-1) unstable; urgency=medium

  * Fix permissions using dpkg-statoverride, not during build
  * Render doc build reproducible
  * Fix test for Perl 5.38 (Closes: #1043239)
  * New upstream version 2.16.2+ds
  * Drop patches included in 2.16.2

 -- Yadd <yadd@debian.org>  Fri, 11 Aug 2023 19:12:44 +0400

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                po-debconf
 Build-Depends-Indep: gpg <!nocheck>,
                      fonts-urw-base35 <!nocheck>,
+                     jq,
                      libapache-session-perl <!nocheck>,
                      libauth-yubikey-webclient-perl <!nocheck>,
                      libauthen-oath-perl <!nocheck>,
@@ -125,7 +126,6 @@
 Section: web
 Depends: ${misc:Depends},
          ${perl:Depends},
-         lsb-base,
          libfcgi-perl,
          libfcgi-procmanager-perl,
          liblemonldap-ng-handler-perl (= ${binary:Version}),

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

LMSHAREDIR=/usr/share/lemonldap-ng
LMVARDIR  =/var/lib/lemonldap-ng
TMP       = $(CURDIR)/debian/tmp

CONFDIR=/etc/lemonldap-ng
export LLNG_SKIP_GPG_TEST=1

%:
	dh $@

override_dh_auto_configure:
	$(MAKE) lemonldap-ng-common/lib/Lemonldap/NG/Common/Conf/Constants.pm \
		fastcgi-server/man/llng-fastcgi-server.8p
	$(MAKE) configure STORAGECONFFILE=/etc/lemonldap-ng/lemonldap-ng.ini \
		PERLOPTIONS="INSTALLDIRS=vendor"

override_dh_auto_build:
	# Generate files excluded from import
	LANG=C $(MAKE) all
	# Extract JOSN from doc index
	cat doc/pages/documentation/current/searchindex.js | perl -pe 's/^.*?(\{.*\}).*?$$/$$1/' >debian/index.json
	# Sort JSON, including arrays
	jq --compact-output 'walk(if type == "array" then sort else if type == "object" then to_entries | sort_by(.key) | from_entries else . end end)' > debian/searchindex.js <debian/index.json
	# Insert new JSON in doc index
	perl -000 -i -pe 'BEGIN{open F,"debian/searchindex.js";$$j=<F>;chomp $$j;close F}s/\{.*\}/$$j/' doc/pages/documentation/current/searchindex.js

override_dh_auto_install:
	$(MAKE) install \
			DESTDIR=$(CURDIR)/debian/tmp \
			PREFIX=/usr \
			LMPREFIX=/usr/share/lemonldap-ng \
			BINDIR=$(LMSHAREDIR)/bin \
			SBINDIR=/usr/sbin \
			FASTCGISOCKDIR=/var/run/llng-fastcgi-server \
			DOCUMENTROOT=$(LMVARDIR) \
			EXAMPLESDIR=/examples \
			HANDLERDIR=$(LMVARDIR)/handler \
			MANAGERDIR=$(LMSHAREDIR)/manager \
			PORTALDIR=$(LMSHAREDIR)/portal \
			STORAGECONFFILE=/etc/lemonldap-ng/lemonldap-ng.ini \
			TOOLSDIR=$(LMSHAREDIR)/ressources \
			CONFDIR=$(CONFDIR) \
			CRONDIR=/etc/cron.d \
			DATADIR=$(LMVARDIR) \
			APACHEVERSION=2.X \
			APACHEUSER=www-data \
			APACHEGROUP=www-data \
			DEFDOCDIR=/usr/share/doc/lemonldap-ng \
			UWSGIYAMLDIR=/etc/uwsgi/apps-available \
			USEDEBIANLIBS=yes
	find $(TMP)/$(LMSHAREDIR) -type f -name '.*.swp' -delete
	# Generate minified files removed by uscan
	for i in $$(find $(TMP)/$(LMSHAREDIR) -type f -name '*.js'); do \
		echo -n "compressing $$i: "; \
		uglifyjs --comments '/Copyr/i' $$i >$${i%%.js}.min.js; \
		echo done; \
	done
	for i in $$(find $(TMP)/$(LMSHAREDIR) -type f -name '*.css'); do \
		echo -n "compressing $$i: "; \
		yui-compressor $$i >$${i%%.css}.min.css; \
		echo done; \
	done

override_dh_compress:
	dh_compress -X favicon.ico

override_dh_missing:
	dh_missing -Xexamples/ -Xetc/cron.d -Xllng-fastcgi-server
